; bevat alle logika om boeken aan te maken, op te zoeken, te deleten en correcties aan te brengen.

(define (vector->string vect)
  (display "vector is")
  (display vect)
  (string-append
     (number->string (vector-ref vect 3)) 
     " "
     (number->string (+ 1 (vector-ref vect 4))) 
     " "
     (number->string (vector-ref vect 5)) 
     " "))
     

; Add a book to DB
; ----------------

; show form
(define (add-book-scm input outputport)
  (output-html-page  "book_add.html" '("%nextpage") '("book-added") outputport))

; voegt een boek toe aan de databank en laat het resultaat zien.
(define (book-added-scm input outputport)
  (newline) (newline)
  (display "inside book-added")
  (newline)
  (define book (Text-2-Book input))
  (if (null? book)
      (output-error "wrong URL-format<br>Not enough information to represent a book" outputport)
      (begin
        (define result (DB-add-book book))
        (if (null? result)
            (output-error "The new book could not be added to the Database." outputport)
            (show-book "book_added.html" book outputport)))))



; Lookup-book
; -----------

; geef form met info om te zoeken
(define (lookup-book-scm input outputport)
  (output-html-page "book_get.html" '("%nextpage") '("select-book-for-lookup") outputport))

; geef selectie (kies boek uit alle matches)
(define (select-book-for-lookup-scm input outputport)
  (display "inside select-book-for-lookup")
  (select-book input outputport "lookup-book-results"
               (lambda (book) (show-book "book_display.html" book outputport))))

; show info on book
(define (lookup-book-results-scm input outputport)
  (define title (get-var-value input "title"))
  (define isbn (get-Var-Value input "isbn"))
  (define copynumber (get-var-value input "copynumber"))
  (if (or (null? title)
          (null? isbn)
	  (null? copynumber))
      (output-error "Unable to form primary key (BOOKS)" outputport)
  (DB-lookup-book-by-primary-key
    (list title isbn copynumber)
    outputport
    (lambda (book) (show-book "book_display.html" book outputport)))))


; Edit book
; ---------

; display form to select book to edit
(define (lookup-book-edit-scm input outputport)
  (display "okidoki")
  (output-html-page "book_get.html" '("%nextpage")
                    '("select-book-for-edit") outputport))

; select book for editing
(define (select-book-for-edit-scm input outputport)
  (select-book input outputport "edit-book"
               (lambda (book) (show-book "book_edit.html" book outputport))))

; edit book
(define (edit-book-scm input outputport)
  (display "form to edit")
  (define title (Get-Var-Value input "title"))
  (define copynumber (Get-Var-Value input "copynumber"))
  (define isbn (Get-Var-Value input "isbn"))
  (DB-lookup-book-by-primary-key
    (list title isbn copynumber)
    outputport
    (lambda (book) (show-book "book_edit.html" book outputport))))


; show status of editing book
(define (edited-book-info-scm input outputport)
  (define title (Get-Var-Value input "title"))
  (define copynumber (Get-Var-Value input "copynumber"))
  (define isbn (Get-Var-Value input "isbn"))
  (DB-lookup-book-by-primary-key
    (list title isbn copynumber)
    outputport
    (lambda (book) (show-book "book_display.html" book outputport))))


; Delete book
; -----------

; show form
(define (delete-book-scm input outputport)
  (output-html-page "book_get.html" '("%nextpage")
                    '("select-book-for-delete") outputport))

; show selection
(define (select-book-for-delete-scm input outputport)
  (select-book
    input
    outputport
    "confirm-book-delete"
    (lambda (book) (show-book "book-confirm-delete.html" book outputport))))

; let the user confirm the deletion
(define (confirm-book-delete-scm input outputport)
  (define book (Text-2-Book input))
  (if (null? book)
      (output-error "wrong input format<BR>This means that the given URL doesn't contain enough information"
                    outputport)
      (show-person "book_confirm_delete.html" book outputport)))

; delete the person, and show result
(define (book-delete-scm input outputport)
  (define isbn (Get-Var-Value input "isbn"))
  (if (not isbn)
      (output-error "not a valid isbnnumber" outputport)
      (begin (define b (Create-Book))
             (b 'set 'isbn isbn)
             (define result (DB-Delete-Book b))
             (cond (result
                     (output-html-page "book_deleted.html" '() '() outputport))
                   (else (output-error "Could not delete person from Database"
                                       outputport))))))


; Uitlenen book
; -------------

; show form to select person voor uitleen
(define (lookup-person-for-loan-scm input outputport)
  (output-html-page "person_get.html" '("%nextpage")
                    '("select-person-for-loan") outputport))

; select person
(define (select-person-for-loan-scm input outputport)
  (select-person
    input
    outputport
    "get-book-for-loan"
    (lambda (person)
      (output-html-page "book_get_for_loan.html" '("%personnumber") 
                        (list (person 'get 'personnumber)) outputport))))

;(define (person-display-for-loan-scm input outputport)
;  (define personnumber (get-var-value input "personnumber"))
;  (if (not personnumber)
;      (output-error "Not enough information" outputport)
;      (let ((person (create-person)))
;        (person 'set 'personnumber personnumber)
;         (let ((result (db-lookup-person person)))
;	  (cond ((null? result)
;	         (output-error "No match" outputport))
;	        ((string? result)
;	         (output-error result outputport))
;		((= (length result) 1)
;		 (display "HERE I AM")
;	         (show-person "person_display_for_loan.html" (car result) outputport)))))))

(define (get-book-for-loan-scm input outputport)
   (define personnumber (get-var-value input "personnumber"))
   (if (not personnumber)
       (output-error "Not enough information" outputport)
       (output-html-page "book_get_for_loan.html"
                        '("%personnumber")
                        (list personnumber)
                        outputport)))

 (define (select-book-for-loan-scm input outputport)
   (define personnumber (Get-Var-Value input "personnumber"))
   (display "inside select-book-for-loan")
   (if (not personnumber)
       (output-error "Not enough information" outputport)
       (select-book-for-loan
         input
         outputport
	 personnumber
         "loan-warranty"
         (lambda (book) (loan-warranty personnumber book outputport)))))
          
(define (loan-warranty-scm input outputport)
  (display "inside confirm-loan-scm")
  (define personnumber (Get-Var-Value input "personnumber"))
  (define bookkey (Get-Primary-Book-Key input)) 
  (cond ((not personnumber) (display "no personnumber") (output-error "Not enough information" outputport))
        ((not bookkey) (display "no bookkey") (output-error "Not enough information" outputport))
	(else 
	  (define result (DB-Lookup-Book bookkey))
	  (display "did lookup")
	  (cond ((string? result) (output-error result outputport))
	        ((null? result) (output-error "No match found for book" outputport))
		((null? (cdr result)) (loan-warranty personnumber (car result) outputport))
		(else (output-error "Not a unique primary book-key" outputport))))))
	        

(define (loan-book-scm input outputport)
  (define loan (Text-2-Loan input))
  (if (not loan)
    (output-error "Not enough information to create loan" outputport)
    (begin 
      ; check all constraints
      (loan 'set 'date (vector->string (getdate)))
      (define result (DB-add-loan loan))
      (display result)
      (cond ((string? result) (output-error result outputport))
            (result (output-html-page "loan_successfull.html" '() '() outputport))
	    (else (output-error "received unknown result from DB"))))))

	
	          
          ; binnenbrengen book
          ; ------------------
          


(define (lookup-book-bringback-scm input outputport)
  (output-html-page "book_get.html" '("%nextpage")
                    '("select-book-bringback") outputport))
  
  
(define (select-book-bringback-scm input outputport)  
  (select-book-from-loan
    input
    outputport
    "bring-back-book"
    (lambda (loan outputport) (display "one match") (delete-loan loan outputport))))
    
(define (bring-back-book-scm input outputport)
  (define loan (Create-Loan))
  (loan 'set 'bookisbn (Get-Var-Value input "isbn"))
  (loan 'set 'booktitle (Get-Var-Value input "title"))
  (loan 'set 'bookcopynumber (Get-Var-Value input "copynumber"))
  (delete-loan loan outputport))
   
(define (delete-loan loan outputport)
  (define result (DB-lookup-loan loan))
  (cond ((string? result) (output-error result outputport))
        ((null? result) (output-error "book was not loaned out" outputport))
	((null? (cdr result))
	  (display "removing book")
	  (define result (remove-loan-from-DB (car result) outputport)))
   	(else (output-error "Book was loaned to several persons at the time" outputport))))
  
(define (remove-loan-from-DB loan outputport)
  (display "inside remove-lmoan-ftom-DB")
  (define result (DB-delete-loan loan))
  (cond ((string? result) (output-error result outputport))
        (result (output-html-page
	           "book_returned.html" 
                   '("%personnumber" "%title" "%warranty")
		   (list (loan 'get 'personnumber)
		         (loan 'get 'booktitle)
			 (loan 'get 'warranty))
	           outputport))
	(else (output-error "received an unexpected esult from DB"))))
        

; borrowed-books
; --------------

(define (borrowed-books-scm input outputport)
  (select-book-from-loan
     input
     outputport
     "super-book-loan-show"
     book-loan-show))

(define (super-book-loan-show-scm input outputport)
   (define loan (create-loan))
   (loan 'set 'personnumber (get-var-value input "personnumber"))
   (loan 'set 'booktitle (get-var-value input "title"))
   (loan 'set 'bookcopynumber (get-var-value input "cnumber"))
   (define result (db-lookup-loan loan))
   (display result)
   (cond ((null? result)
          (output-error "no match for lookup" outputport))
	 ((string? result)
	  (output-error result outputport))
	 ((not (null? (cdr result)))
	  (output-error "no unique match on loan" outputport))
	 (else (book-loan-show (car result) outputport))))
     
     (define (book-loan-show loan outputport)
         (display "entering book-loan")
         (define book-query (create-book))
	 (define person-query (create-person))
	 (book-query 'set 'title (loan 'get 'booktitle))
         (book-query 'set 'isbn (loan 'get 'bookisbn))
	 (book-query 'set 'copynumber (loan 'get 'bookcopynumber))
	 (person-query 'set 'personnumber (loan 'get 'personnumber))
	 (define book (db-lookup-book book-query))
	 (define person (db-lookup-person person-query))
	 (display "hello")
	 (cond ((or (null? book)
	            (null? person))
		(output-error "No book-person match found" outputport))
	       ((string? book)
	        (output-error book outputport))
	       ((string? person)
	        (output-error person outputport))
	       ((and (null? (cdr book))
	             (null? (cdr person)))
		(show-loan "loan_show.html" loan (car person) (car book) outputport))
	       (else (output-error "No unique person-book match found" outputport))))





          ; Generische en hogere ordefuncties op boeken
          ; -------------------------------------------
          
          
          ; neemt een template, spliced hierin alle book-data en stuurt deze terug naar de gebruiker.
          (define (show-book templatefile book outputport)
            (output-html-page templatefile
                             '("%title" "%author" "%publisher" "%date" "%isbn" "%section" "%copynumber")
                              (list
                                (book 'get 'title)
                                (book 'get 'author)
                                (book 'get 'publisher)
                                (book 'get 'date)
                                (book 'get 'isbn)
                                (book 'get 'section)
                                (book 'get 'copynumber))
                              outputport))
          
          
          
          ; laat een selectie zien van boeken
          (define (generate-book-list book-list outputport nextpage)
            (define (show-book-line book)
              (output-html-page "book_body.html"
                                '("%nextpage" "%isbn" "%title" "%cnumber" "%author")
                                (list nextpage
                                      (book 'get 'isbn)
                                      (book 'get 'title)
				      (book 'get 'copynumber)
                                      (book 'get 'author))
                                outputport))
            (define (iter bl)
              (cond ((null? bl) #t)
                    (else (show-book-line (car bl))
                          (iter (cdr bl)))))
            (iter book-list))
          
          
          ; genereert een lijst van books
          (define (select-book input outputport nextpage directaction) ;action to perform when only one match
            (display "inside lookup-book")
            (define book (Text-2-Book input))
            (if (null? book)
	        (begin 
                  (output-error "wrong URL-format<br>Not enough information to represent a book" outputport)
		  (display "book is null"))
                (begin
                  (define result (DB-lookup-Book book))
                  (display "    result of lookup in DB was   ") (display result)
                  (display "going to create output of lookup-person")
                  (cond ((null? result) ; no match for lookup
                         (output-html-page "error.html" '("%error")
			    (list "No matches were found for query") outputport))
                        ((string? result)
			 (output-error result outputport))
			((null? (cdr result)) (directaction (car result)))   ;one match
                        (else ; several matches
                          (output-html-page "book_header.html" '() '() outputport)
                          (generate-book-list result outputport nextpage)
                          (output-html-page "book_footer.html" '() '() outputport))))))
          
          
          (define (DB-lookup-book-by-primary-key key outputport action)
            (if (not (list? key))
                (output-error "Not a valid primary key" outputport)
                (begin (define b (Create-Book))
		       (b 'set 'title (car key))
                       (b 'set 'isbn (cadr key))
		       (b 'set 'copynumber (cadr (cdr key)))
                       (define book (DB-Lookup-Book b))
                       (cond ((null? book)
                              (output-error "Could not find book in Database" outputport))
                             ; edit the folowing line !!!!!
                             ((null? (cdr book))  ; one match
                              (action (car book)))
                             (else (output-error"book-key is not unique !!!" outputport))))))


(define (Get-Primary-Book-Key input)
  (define title (get-var-value input "title"))
  (define isbn (get-Var-Value input "isbn"))
  (define copynumber (get-var-value input "copynumber"))
  (if (or (null? title) (null? isbn) (null? copynumber))
    #f
    (begin 
      (define bookkey (Create-Book))
      (bookkey 'set 'title title)
      (bookkey 'set 'isbn isbn)
      (bookkey 'set 'copynumber copynumber)
      bookkey)))



(define (generate-book-list-for-loan personnumber book-list outputport nextpage)
            (define (show-book-line book)
              (output-html-page "loan_body.html"
                                '("%nextpage" "%personnumber" "%isbn" "%title" "%cnumber" "%author")
                                (list nextpage
				      personnumber
                                      (book 'get 'isbn)
                                      (book 'get 'title)
				      (book 'get 'copynumber)
                                      (book 'get 'author))
                                outputport))
            (define (iter bl)
	      (display " itering")
              (cond ((null? bl) #t)
                    (else (show-book-line (car bl))
                          (iter (cdr bl)))))
            (iter book-list))
          
          
          ; genereert een lijst van books
          (define (select-book-for-loan input outputport personnumber nextpage directaction) ;action to perform when only one match
            (display "inside lookup-book")
            (define book (Text-2-Book input))
            (if (null? book)	
              (begin 
                  (output-error "wrong URL-format<br>Not enough information to represent a book" outputport)
		  (display "book is null"))
                (begin
                  (define result (DB-lookup-Book book))
                  (display "    result of lookup in DB was   ") (display result)
                  (display "going to create output of lookup-loan")
                  (cond ((null? result) ; no match for lookup
                         (output-error "No matches were found for query" outputport))
                        ((string? result)
			 (output-error result outputport))
			((null? (cdr result)) 
			(display "directaction")
			(directaction (car result)))   ;one match
                        (else ; several matches
	                  (output-html-page "loan_header.html" '() '() outputport)
                          (generate-book-list-for-loan personnumber result outputport nextpage)
                          (output-html-page "loan_footer.html" '() '() outputport))))))
         



(define (loan-warranty personnumber book outputport)
  (display "inside confirm-loan")
  (define p (Create-Person))
  (p 'set 'personnumber personnumber)
  (define result (DB-Lookup-Person p))
  (cond ((string? result) (output-error result outputport))
        ((null? result) (output-error "no match was found !!!" outputport))
	((null? (cdr result)) (show-loan "loan_warranty.html" (create-loan) (car result) book outputport))
	(else (output-error "Personnumber not unique" outputport))))
   
         


(define (show-loan templatefile loan person book outputport) ;shows te list of all properties of a person just list, no form
  (display "showing loan")
  (output-html-page templatefile
 
                    '("%personnumber" "%membernumber" "%name" "%firstname"
                    "%studentid" "%function" "%direction" "%email" "%address1" "%phone1"
		    "%address2" "%phone2" "%internalphone" "%lastmemberyear" "%status"
		    "%dinfntlogin" "%login" "%password" "%accesslevel"
                    "%title" "%author" "%publisher" "%date" "%isbn" 
		    "%section" "%copynumber" "%date")
                             
                    (list		    
                      (person 'get 'personnumber)
                      (person 'get 'membernumber)
                      (person 'get 'name)
                      (person 'get 'firstname)
                      (person 'get 'studentid)
                      (person 'get 'function)
                      (person 'get 'direction)
                      (person 'get 'email)
                      (person 'get 'address1)
                      (person 'get 'phone1)
                      (person 'get 'address2)
                      (person 'get 'phone2)
                      (person 'get 'internalphone)
                      (person 'get 'lastmemberyear)
                      (person 'get 'status)
                      (person 'get 'dinfntlogin)
		      (person 'get 'login)
		      (person 'get 'password)
                      (person 'get 'accesslevel)
		      (book 'get 'title)
                      (book 'get 'author)
                      (book 'get 'publisher)
                      (book 'get 'date)
                      (book 'get 'isbn)
                      (book 'get 'section)
                      (book 'get 'copynumber)
		      (loan 'get 'date))
                     outputport))






 ; laat een selectie zien van uitgeleende boeken
 (define (generate-loan-list loan-list outputport nextpage)
   (define (show-loan-line loan)
   (output-html-page "loan_body.html"
                     '("%nextpage" "%personnumber" "%isbn" "%title" "%cnumber")
                      (list nextpage
		      (loan 'get 'personnumber)
                      (loan 'get 'bookisbn)
                      (loan 'get 'booktitle)
                      (loan 'get 'bookcopynumber))
		      outputport))
		      
   (define (iter ll)
     (display "itering")
     (cond ((null? ll) #t)
           (else (show-loan-line (car ll))
	         (iter (cdr ll)))))
(iter loan-list))



          ; genereert een lijst van books die zijn uitgeleend
          (define (select-book-from-loan input outputport nextpage directaction) ;action to perform when only one match
            (display "inside lookup-loan")
	    (define loan (Create-Loan))
	    (define in (Get-Var-Value input "title"))
	    (set! in (if (null? in) "" in))
	    (display in)
	    (loan 'set 'booktitle in)
	    (define in (Get-Var-Value input "isbn"))
	    (set! in (if (null? in) "" in))
	    (display in)
	    (loan 'set 'bookisbn in)
	    (define in (Get-Var-Value input "copynumber"))
	    (set! in (if (null? in) "" in))
	    (display in)
	    (loan 'set 'bookcopynumber in)
	    
            (if (null? loan)
	        (begin 
                  (output-error "wrong URL-format<br>Not enough information to represent a book" outputport)
		  (display "book is null"))
                (begin
                  (define result (DB-lookup-Loan loan))
	          (display "    result of lookup in DB was   ") (display result)
                  (display "going to create output of lookup-loan")
                  (cond ((null? result); no match for lookup
                         (output-error "No matches were found for query" outputport))
                        ((string? result)
			 (output-error result outputport))
			((null? (cdr result))
			 (directaction (car result) outputport))   ;one match
                        (else ; several matches
                          (output-html-page "book_header.html" '() '() outputport)
                          (generate-loan-list result outputport nextpage)
                          (output-html-page "book_footer.html" '() '() outputport))))))
          


(define (book-2-loan book)
  (display "entering book-2-loan")
  (define loan (Create-Loan))
  (display "ok")
  (book 'get 'title)
  (display "boe")
  (loan 'set 'booktitle (book 'get 'title))
  (display "title")
  (loan 'set 'bookisbn (book 'get 'isbn))
  (display "isbn")
  (loan 'set 'bookcopynumber (book 'get 'copynumber))
  (display "copynumber")
  (display "exiting book-2-loan")
  loan)


