  ;*******************
  ;*  The database I/O    *
  ;*******************
  ; De output naar de database functies gebeurt via een vector met alle velden in. De database functies zijn
  ; primitieven gemaakt in de Scheme-interpreter in Java.
  
  ; ObjectToVector zet een object's informatie om naar een vector. De vector bestaat uit alle waarden van
  ; de velden van het object in een overeengekomen volgorde.

(define (Object-To-Vector object) ;private
  (define fields (object 'getfields))
  (define max (length fields))
  (define output-vector (make-vector max))
  (define (iter pos)
    (if (>= pos max)
        output-vector
        (begin (vector-set! output-vector pos (object 'get (list-ref fields pos)))
               (iter (+ pos 1)))))
  (iter 0))
  
  ; VectorToObject zet een vector die uit waarden van velden bestaat om naar een object.
  ; De volgorde van de velden is overeengekomen in het protocol.

(define (Vector-To-Object vect constructor) ;private
  (define object (constructor))
  (define fields (object 'getfields))
  (define max (vector-length vect))
  (define (iter pos)
    (if (>= pos max)
        object
        (begin (object 'set (list-ref fields pos) (vector-ref vect pos))
               (iter (+ pos 1)))))
  
  (cond ((not (= max (length fields)))
         '())
        (else (iter 0))))
	
  ; DB_AddPerson voegt een member toe aan de databank. (#t / #f)

(define (DB-Add-Person personobject) ;public
(display "DB-ADD- PERSON ENTERED")
(newline)
  (define open-result (open-db))
  (display "OPEN RESULT :")
  (display open-result)
  (newline)
  (cond ((vector? open-result)
         (let* ((personnumber (db-new-personnumber))
	        (status (personobject 'get 'status))
		(number (cond ((or (string=? status "member")
		                   (string=? status "debugger"))
		               (db-new-membernumber))
			      ((string=? status "honorarymember")
			       (db-new-honorarynumber))
			      (else ""))))
			      
	    (personobject 'set 'personnumber personnumber)
	    (personobject 'set 'membernumber number)
	    (display "NEW NUMBERS GENERATED :")
	    (display number)
	    (display ",")
	    (display personnumber)
	    (newline)
	    (let ((result (db-add "PERSON" (Object-To-Vector personobject))))
                (display "result: ")(display result)(newline)
                (close-db)
                (cond ((vector? result)
		       (display "OKEE")
		       (newline)
	               #t)
		      ((string? result)
		      (display "ERROR STRING :")
		      (display result)
		      (newline)
		       result)
                      (else "Database did not produce expected result (ADD)")))))
		      
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))
        
  
  ; DB_DeletePerson verwijdert een member uit de databank. (#t / #f)
(define (DB-Delete-Person personobject) ;public
  (display "ENTERING DELETE ")
  (display (personobject 'get 'personnumber))
  (define open-result (open-db))
  (cond ((vector? open-result)
         (let ((result (db-delete "PERSON"  (Object-to-vector personobject))))
	   (close-db)
	   (display "DELETE RESULT :")
	   (display result)
	   (newline)
	   (cond ((vector? result)
                  #t)
         	  ((string? result)
	           result)
	          (else "Database did not produce expected result (DELETE)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))

      
  ; DB_LookupPerson zoekt een member op
(define (DB-Lookup-Person personobject) ;public
 (define open-result (open-db))
 (display "Ebntering DB-Lookup Person")
 (display " RESULT OF DB-OPEN :")
 (display open-result)
 (cond ((vector? open-result)
        (let ((result (db-lookup "PERSON" (Object-To-Vector personobject))))
	  (display "RESULT OF DB-LOOKUP : ")
	  (display result)
	  (newline)
	  (close-db)
          (cond ((vector? result)
	         (display "OK")
                 (let ((x (vector-length result))
                  (memblist '()))
              
                 (do ((index x (- index 1)))
                     ((<= index 0) (begin (display memblist) memblist))
                     (set! memblist (cons (Vector-To-Object (vector-ref result (- index 1)) Create-Person)
                                       memblist)))))
	        ((string? result)
	         result)
	        (else "Database did not produce expected result (LOOKUP)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))
  
(define (DB-Replace-Person personobject) ;public
  (display "ENTERING REPLACE ")
  (define open-result (open-db))
  (cond ((vector? open-result)
         (let ((result (db-replace "PERSON"  (Object-to-vector personobject))))
	   (close-db)
	   (display "REPLACE RESULT :")
	   (display result)
	   (newline)
	   (cond ((vector? result)
                  #t)
         	  ((string? result)
	           result)
	          (else "Database did not produce expected result (REPLACE)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))



(define (DB-Add-book book-object)
 (define open-result (open-db))
  (cond ((vector? open-result)
         (let ((result (db-add "BOOK" (Object-To-Vector book-object))))
	   (close-db)
           (cond ((vector? result)
                  #t)
	         ((string? result)
	          result)
	         (else "Database did not produce expected result (ADD-BOOK)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))


(define (DB-Delete-book book-object) ;public
  (define open-result (open-db))
  (cond ((vector? open-result)
         (let ((result (db-delete "BOOK" (Object-to-vector book-object))))
	   (close-db)
	   (cond ((vector? result)
                  #t)
         	  ((string? result)
	           result)
	          (else "Database did not produce expected result (DELETE)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))


(define (DB-Lookup-book bookobject) ;public
 (define open-result (open-db))
 (display "ENTERING DB-LOOKUP BOOK")
 (display "Result of open=db :")
 (display open-result)
 (cond ((vector? open-result)
        (let ((result (db-lookup "BOOK" (Object-To-Vector bookobject))))
	  (display "Result of DB-LOOKUP : ")
	  (display result)
	  (newline)
	  (close-db)
          (cond ((vector? result)
                 (let ((x (vector-length result))
                  (memblist '()))
              
                 (do ((index x (- index 1)))
                     ((<= index 0) (begin (display "BOOKOUT") memblist))
                     (set! memblist (cons (Vector-To-Object (vector-ref result (- index 1)) Create-book)
                                       memblist)))))
	        ((string? result)
	         result)
	        (else "Database did not produce expected result (LOOKUP)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))


(define (DB-Add-Loan loan-object)
 (define open-result (open-db))
 (display "ENTERING ADD-LOAN ")
 (display "RESULT OF OPEN-DB : ")
 (display open-result)
  (cond ((vector? open-result)
         (let ((new-loannumber (db-new-loannumber)))
	 	 (loan-object 'set 'loannumber new-loannumber)
	         (define result (db-add "LOAN" (Object-To-Vector loan-object)))
	         (display "RESULT of DB-ADD LOAN : ")
		 (display result)
		 (close-db)
                 (cond ((vector? result)
                        #t)
	               ((string? result)
	                result)
	               (else "Database did not produce expected result (ADD-LOAN)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))
	 

(define (DB-Delete-Loan loan-object)
  (define open-result (open-db))
  (display " ENTERING DELETE LOAN ")
  (display " Result of open-db")
  (display open-result)
  (cond ((vector? open-result)
         (let ((result (db-delete "LOAN" (Object-To-Vector loan-object))))
	    (display " RESULKT OF DB-DELETE loan ")
	    (display result)
	    (close-db)
            (cond ((vector? result)
                   #t)
	          ((string? result)
	           result)
	          (else "Database did not produce expected result (DEL-LOAN)"))))
        ((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))

(define (DB-Lookup-loan loanobject) ;public
 (define open-result (open-db))
 (display "ENTERING LOOKUP LOAN RESULT OF OPEN : ")
 (display open-result)
 (cond ((vector? open-result)
        (let ((result (db-lookup "LOAN" (Object-To-Vector loanobject))))
	  (display "RESULT OF DB-LOOKUP loan")
	  (display result)
	  (close-db)
          (cond ((vector? result)
                  (let ((x (vector-length result))
                  (memblist '()))
              
                 (do ((index x (- index 1)))
                     ((<= index 0) memblist)
                     (set! memblist (cons (Vector-To-Object (vector-ref result (- index 1)) Create-loan)
                                       memblist)))))
	        ((string? result)
	         result)
	        (else "Database did not produce expected result (LOOKUP)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))


(define (DB-Replace-Loan loan-object)
  (define open-result (opendb))
  (cond ((vector? open-result)
         (let ((result (db-replace "LOAN" loan-object)))
	   (close-db)
	   (cond ((vector? result)
	          #t)
		 ((string? result)
		  result)
		 (else "Database did not produce expected result (REPLACE)"))))
	((string? open-result)
	open-result)
	(else "Database did not produce expected result (REPLACE OPEN)")))


(define (DB-Add-Room-Reservation reserv-object)
 (display "IN ADD ROOM")
 (define open-result (open-db))
  (cond ((vector? open-result)
         (define new-number (db-new-reservationnumber))
	 (reserv-object 'set 'reservationnumber new-number)
         (let ((result (db-add "RESERV" (Object-To-Vector reserv-object))))
	   (close-db)
           (cond ((vector? result)
                  #t)
	         ((string? result)
	          result)
	         (else "Database did not produce expected result (ADD-RESERV)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))


(define (DB-Delete-Room-Reservation reservation-object) ; public
 (define open-result (open-db))
  (cond ((vector? open-result)
         (let ((result (db-delete "RESERV" (Object-To-Vector reservation-object))))
	   (close-db)
           (cond ((vector? result)
                  #t)
	         ((string? result)
	          result)
	         (else "Database did not produce expected result (DEL-RESERV)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))

   
(define (DB-lookup-Room-Reservation reservation-object)
  (define open-result (open-db))
   (cond ((vector? open-result)
          (let ((result (db-lookup "RESERV" (Object-To-Vector reservation-object))))
	  (close-db)
          (cond ((vector? result)
                 (let ((x (vector-length result))
                  (memblist '()))
              
                 (do ((index x (- index 1)))
                     ((<= index 0) memblist)
                     (set! memblist (cons (Vector-To-Object (vector-ref result (- index 1)) Create-Reservation)
                                       memblist)))))
	        ((string? result)
	         result)
	        (else "Database did not produce expected result (LOOKUP RESERV)"))))
	((string? open-result)
	 open-result)
        (else "Database did not produce expected result (OPEN)")))

