(define (Text2Object text) ;private
  ; index in de text bijhouden
  (define index 0)
  ; toestandsvariable wordt op #f gezet bij fout verloop
  (define status #t)
  (define textlength (string-length text))

  ; functie die alles inleest vanaf de huidige index tot een &  (dus leest de value van een variable in)
  (define (ReadVal)
    (define start index)
    (define stop (indexof text "&" index))
    (set! index (+ stop 1))
    (if (= stop -1)
        (set! status #f) 
        (substring text start stop)))
    
  ; functie die alles inleest vanaf de huidige index tot een = (dus leest de naam van een variable in)
  (define (ReadVar)
    (define start index)
    (define stop (indexof text "=" index))
    (set! index (+ stop 1))
    (if (= stop -1)
        (set! status #f)
	(substring text start stop)))

  (define (Buildobject)
    ; moek nog ezens naar zien
    (define result #f)
    
    (define (build-iter)
      (cond ((or (>= index textlength) (not status))
             result)
            (else
              (let ((varname (ReadVar))
	            (varvalue (ReadVal)))
	        (set! result (cons (cons varname varvalue) result))
		(build-iter)))))
    (build-iter))
  
  ; lopen tot aan het vraagteken waarna de informatie volgt
  (let ((questionindex (indexof text "?")))
     (if (= questionindex -1)
         #f
	 (begin
	    (set! index (+ questionindex 1))
	    (cdr (BuildObject))
	    ))))

(define (getpagetag str)
  (define index (indexof str ".scm"))
  (if (= index -1)
      ""
      (substring str 5 index)))
 
(define (home-page name)
  (define p (open-input-file name))
  (if p
    (begin
      (define str (read-string p))
      (close p)
      str)
    #f))

(define selfs (make-vector 100))

(define (wipeselfs)
  (define i 0)
  (define i 0)
  (define tmp #f)
  ; flush al de onnodige request
  (while (< i 100)
    (set! tmp (vector-ref selfs i))
    (if (and tmp (> (- (ticks) (car tmp)) 20000))
        (begin
	  (vector-set! selfs i #f)
	  (display "kicked ")
	  (display (number->string i))))
    (set! i (+ i 1))))

(define (newselfnr)
  (define i 0)
  (while (and (< i 100) (vector-ref selfs i)) (set! i (+ i 1)))
  (vector-set! selfs i (cons (ticks) #f))
  (display "new selfke")
  (set! selfnr i)
  i)
  
(define refreshcounter 0)

(define (lookup varvals name)
  (cond ((not varvals) #f)
        ((eq? (car (car varvals)) name) (cdr (car varvals)))
	(else (lookup (cdr varvals) name))))
  
(define selfnr #f)
(define self #f)

(define (valid-selfnr)
  (set! self (vector-ref selfs selfnr))
  (display "self = ")
  (display self)
  (if self
      (begin
        (set! self (cdr self))
	#t)
      (begin
        (set! selfnr #f)
	#f)))
      
(define (eval-http inport outport)
  (define fullurl (readstring inport))
  (display fullurl)
  (define pagetag (getpagetag fullurl))
  (define varvals (text2object fullurl))
  
  ; rommel wegkiepen + self omzetten naar integer
  (wipeselfs)
  (set! selfnr (lookup varvals "self"))
  (display "selfnr")
  (display selfnr)
  (newline)
  (if selfnr (set! selfnr (string->number selfnr)))
  (if (and selfnr (not (valid-selfnr)))
      (begin
        (display "MEGASMOS")
	(set! pagetag "timeout")))
  
  ; evalueer de functie
  (define function-name (string->symbol (string-append pagetag "-scm")))
  (define outstr "")
  (if (not (defined function-name))
      (begin
        (set! outstr (home-page (string-append pagetag ".html")))
        (if (not outstr)
  	    (set! outstr (no-url-scm varvals))))
      (set! outstr (apply (eval function-name) (list varvals))))
      
  ;uitvoeren met nummer indien nodig
  (if (!= (indexof outstr "%self") -1)
      (set! outstr (replace outstr "%self" (number->string selfnr))))
  (set! refreshcounter (+ refreshcounter 1))
  (set! outstr (replace outstr "%random" (number->string refreshcounter)))
  (writestring outstr outport)
  )
  
;-------------------------------------------------------------
; elke html/scheme functie moet nen string weergeven
(define (-scm varvals)
  (login-request-scm varvals))

(define (no-url-scm varvals)
  (home-page "bad-request.html"))
  
(define (login-request-scm varvals)
  (home-page "login-request.html"))
  
(define (main-scm varvals)
  (if (and (= (lookup varvals "name") "kathy")
           (= (lookup varvals "passwd") "rubbens"))
      (begin
        (newselfnr)
	(home-page "main.html"))
      (home-page "login-request.html")))

(define (get-person-request-scm varvals)
  (home-page "get-person-request.html"))

(define (get-person-scm varvals)
  (string-append
    (home-page "get-person-request.html")
    "OPGEZOCHT"))
