
(define (list? x)
  #t)

; The IG permanentieclient

;*****************
;*  DATA OBJECTS  *
;*****************

;---------------------------------------------------PERSON OBJECT-----------------------------------------------
; Hieronder volgt de objectconstructor van het member-object.
; Het object accepteert messages op de volgende manier :
; (<object> 'set '<varname> <varvalue>)
; (<object> 'get '<varname> <varvalue>)

(define (Create-Person)
  ; velden expliciet bijhouden voor later in de ObjectToVector functies
  (define fields '(personnumber
                    firstname
                    name
                    studentid
                    email
                    address1
                    address2
                    phone1
                    phone2
                    internalphone
                    membernumber
                    lastmemberyear
                    function
                    direction
                    status
                    accesslevel
		    login
		    password
		    dinfntlogin))
  
  (define firstname "")
  (define name "")
  (define studentid "")
  (define email "")
  (define address1 "")
  (define address2 "")
  (define phone1 "")
  (define phone2 "")
  (define internalphone "")
  (define membernumber "")
  (define lastmemberyear "")
  (define function "")
  (define direction "")
  (define status "")
  (define accesslevel "")
  (define dinfntlogin "")
  (define personnumber "")
  (define login "")
  (define password "")
  
  (define (get varname)
    (if (string? varname)
        (set! varname (string->symbol varname)))
    (eval (eval varname)))
  
  (define (set varname value)
    (if (string? varname)
        (set! varname (string->symbol varname)))
    
    (if (member varname fields)
        (eval (list 'set! varname value))))
  
  (define (getfields)
    fields)
  
  (lambda (msg . args)
    (apply (eval msg) args )))

;---------------------------------------------------BOOK OBJECT-----------------------------------------------

; documentatie is idem aan die bij member objecten

(define (Create-Book) ;private
  (define fields '(title
                    author
                    publisher
                    date
                    isbn
                    section
                    copynumber))
  (define title "")
  (define author "")
  (define publisher "")
  (define date "")
  (define isbn "")
  (define section "")
  (define copynumber "")
  
  (define (get name)
    (if (string? name)
        (set! name (string->symbol name)))
    (eval (eval name)))
  
  (define (set name value)
    (if (string? name)
        (set! name (string->symbol name)))
    
    (if (member name fields)
        (eval (list 'set! name value))))
  
  (define (getfields)
    fields)
  
  (lambda (msg . args)
    (apply (eval msg) args)))

;---------------------------------------------------UITLENING OBJECT-----------------------------------------------
; documentatie is idem aan die bij member objecten

(define (Create-Loan) ;private
  (define fields '(loannumber
                    personnumber
                    booktitle
		    bookisbn
		    bookcopynumber
                    date
                    warranty) )
  
  (define loannumber "")
  (define personnumber "")
  (define booktitle "")
  (define bookisbn "")
  (define bookcopynumber "")
  (define date "")
  (define warranty "")
  
  (define (get name)
    (if (string? name)
        (set! name (string->symbol name)))
    (eval (eval name)))
  
  (define (set name value)
    (if (string? name)
        (set! name (string->symbol name)))
    
    (if (member name fields)
        (eval (list 'set! name value))))
  
  (define (getfields)
    fields)
  
  (lambda (msg . args)
    (apply (eval msg) args)))

;---------------------------------------------------RESERVATIE OBJECT-----------------------------------------------
; documentatie is idem aan die bij member objecten

(define (Create-Reservation) ; private
  (define fields '(reservationnumber
                    id
                    room
                    start
                    stop
                    day
                    week
                    course))
  
  (define reservationnumber "")
  (define id "")
  (define room "")
  (define start "")
  (define stop "")
  (define week "")
  (define course "")
  (define day "")
  
  (define (get name)
    (if (string? name)
        (set! name (string->symbol name)))
    (eval (eval name)))
  
  (define (set name value)
    (if (string? name)
        (set! name (string->symbol name)))
    
    (if (member name fields)
        (eval (list 'set! name value))))
  
  (define (getfields)
    fields)
  
  (lambda (msg . args)
    (apply (eval msg) args)))
  
  ;****************************
  ;*  TEXT 2 OBJECT FUNCTIES  *
  ;****************************
  
(define (Get-Var-Value text var)
  ; index in de text
  (define index 0)
  (define status #t)
  ; lengte van de text bijhouden om indexering buiten array te voorkomen
  (define textlength (string-length text))
  ; functie die de value zelf inleest
  (define (ReadVal)
    (define start index)
    (define stop (indexof text "&" index))
    (set! index (+ stop 1))
    (if (= stop -1)
        (set! status #f)
        (substring text start stop)))
  
  (define (ReadVar)
    (define start index)
    (define stop (indexof text "=" index))
    (set! index (+ stop 1))
    (if (= stop -1)
        (set! status #f)
        (substring text start stop)))
  
  (define (iter)
    (define varname (ReadVar))
    (define varvalue (ReadVal))
    (cond ((not status)
           '())
          ((string=? varname var)
           varvalue)
          (else (iter))))
  
  ; lopen tot aan het ? (alles daarvoor is nutteloos)
  (let ((questionindex (indexof text "?")))
    (if (= questionindex -1)
        '()
        (begin
          (set! index (+ questionindex 1))
          (iter)))))
  
  
  
  ; Text to Object converters
  ; Hiermee wordt de input vanuit de forms geconverteerd naar een formaat handig in Scheme. Dit formaat
  ; zijn de objecten member, reservatie, boek,...
  ; Text2Object is een hoger orde functie waardoor het gebruike ervan generisch wordt. Men geeft
  ; de juiste objectconstructor mee en er wordt van <text> een object gemaakt dmv deze constructor.
  ; indien de text fouten bevat geeft deze functie '() terug.
  
(define (Text-2-Object text objectconstructor) ;private
  ; index in de text bijhouden
  (define index 0)
  ; toestandsvariable wordt op #f gezet bij fout verloop
  (define status #t)
  ; bijhouden van aantal ingelezen argumenten
  (define argindex 0)
  (define textlength (string-length text))
  
  ; functie die alles inleest vanaf de huidige index tot een &  (dus leest de value van een variable in)
  (define (ReadVal)
    (define start index)
    (define stop (indexof text "&" index))
    (set! index (+ stop 1))
    (if (= stop -1)
        (set! status #f)
        (substring text start stop)))
  
  
  ; functie die alles inleest vanaf de huidige index tot een = (dus leest de naam van een variable in)
  (define (ReadVar)
    (define start index)
    (define stop (indexof text "=" index))
    (set! index (+ stop 1))
    (if (= stop -1)
        (set! status #f)
        (substring text start stop)))
  
  
  (define (Buildobject)
    (define object (objectconstructor))
    (define fields (object 'getfields))
    (define maxi (length fields))
    
    (define (build-iter)
      (cond ((= argindex maxi)
             object)
            ((>= index textlength)
             (set! status #f)
             '())
            (else
              (let ((varname (ReadVar))
                    (varvalue (ReadVal)))
                
                (cond ((not status)
                       '())
                      ((member (string->symbol varname) fields)
                       (object 'set varname varvalue)
                       ;(display "adding ")
                       ;(display varname)
                       ;(display " : ")
                       ;(display varvalue)
                       ;(newline)
                       (set! argindex (+ argindex 1))
                       (build-iter))
                      (else (build-iter)))))))
    (build-iter))
  
  ; lopen tot aan het vraagteken waarna de informatie volgt
  (let ((questionindex (indexof text "?")))
    (if (= questionindex -1)
        '()
        (begin
          (set! index (+ questionindex 1))
          ;PASSWD skippen
          ;(ReadVar)
          ;(ReadVal)
          ;return-waarde : het object
          (let ((object (BuildObject)))
            (if status
                object
                '()))))))
  
  
  ; Clients van de Text2Object functie om specifieke objecten om te zetten
(define (Text-2-Person text) ;public
  (Text-2-Object text Create-Person))
  
(define (Text-2-Book text) ;public
  (Text-2-Object text Create-Book))
  
(define (Text-2-Loan text) ;public
  (Text-2-Object text Create-Loan))
  
(define (Text-2-Reservation text) ;public
  (text-2-Object text Create-Reservation))

