; deze file bevat de logistieke implementatie vor elke page.

; Errors
; ------

(define (undefined-page-error input outputport . tag)
  (display "invalid page-tag not recognized ")
  (display tag)
  (newline))

(define (output-error error outputport)
  (display "ERROR HTML")
  (output-html-page "error.html" '("%error") (list error) outputport)
  ; write to log
  (send-error error)
  )

(define (wrong-URL-format input outputport procname)
  (display "inside wrong_URL_format")
  (output-html-page "wrong_URL_format.html"
                    '("%input" "%procname")
                    (list input procname)
                    outputport)
  ; write-to-log
  ; mailto_supervisor
  )



; Add a person to DB
; ------------------

; display form to fill in to add member
(define (add-person-scm input outputport)
  (output-html-page "person_add.html" '() '() outputport))

; display some info after member has been added
(define (person-added-scm input outputport)
  (define person (Text-2-Person input))
  (if (null? person)
      (wrong-URL-format input outputport "add-person")
      (begin  
        (define result (DB-add-person person))
        (display "result is :")
        (display result)
        (newline)
        (display (string? result))
        (newline)
        (if (string? result)
            (output-error result outputport)
            (show-person "person_added.html" person outputport)))))

; Lookup person in DB
; -------------------

; display form for lookup
(define (lookup-person-scm input outputport)
  (output-html-page "person_get.html" '("%nextpage")
                    '("select-person") outputport))

; display selection for the right user
(define (select-person-scm input outputport)
  (select-person input outputport "lookup-person-results"
                 (lambda (person)
(display "inside lambda")
(show-person "person_display.html" person outputport))))

; display the all the users info
(define (lookup-person-results-scm input outputport)
  (define personnumber (Get-Var-Value input "personnumber"))
  (DB-lookup-person-by-number
    personnumber
    outputport
    (lambda (person) (show-person "person_display.html" person outputport))))



; Edit person in DB
; -----------------

; display form to select person to edit
(define (lookup-person-edit-scm input outputport)
  (output-html-page "person_get.html" '("%nextpage")
                    '("select-person-for-edit") outputport))

; select user for editing
(define (select-person-for-edit-scm input outputport)
  (select-person input outputport "edit-person"
                 (lambda (person) (show-person "person_edit.html" person outputport))))

; edit user
(define (edit-person-scm input outputport)
  ;displays form with all info. All info except personnumber can  be changed
  (display "form to edit")
  ;(define person (Text-2-Person input))
  (define personnumber (Get-Var-Value input "personnumber"))
  (display "text-2-person succesfull")
  (DB-lookup-person-by-number
    personnumber
    outputport
    (lambda (person) (show-person "person_edit.html" person outputport))))


; show status of editing user
(define (edited-person-info-scm input outputport)
  (display "start edited-person-info-scm")
  (define person (Text-2-Person input))
  (display "start DB-replaceeeeeeeeeeeee")
  (DB-replace-person-for-replace
    person
    outputport
    (lambda (person) (display "inside lambda") 
                     (show-person "person_display.html" person outputport))))


; Delete Person
; -------------

; show form
(define (delete-person-scm input outputport)
  (output-html-page "person_get.html" '("%nextpage")
                    '("select-person-for-delete") outputport))

; show selection
(define (select-person-for-delete-scm input outputport)
  (select-person
    input
    outputport
    "confirm-person-delete"
    (lambda (person) (show-person "person_confirm_delete.html" person outputport))))

; let the user confirm the deletion
(define (confirm-person-delete-scm input outputport)
  (define personnumber (Get-Var-Value input "personnumber"))
  (DB-lookup-person-by-number
    personnumber
    outputport
    (lambda (person)
      (show-person "person_confirm_delete.html" person outputport))))

; delete the person, and show result
(define (person-delete-scm input outputport)
  (define personnumber (Get-Var-Value input "personnumber"))
  (define confirm (Get-Var-Value input "confirm"))
  (cond ((not personnumber)
         (output-html-page "error.html" '("%error") '("not a valid personnumber") outputport))
        ((string=? confirm "no")
         (output-html-page "person_not_deleted.html" '() '() outputport))
       
       (else (define p (Create-Person))
             (p 'set 'personnumber personnumber)
             (define result (DB-Delete-Person p))
             (cond (result
                     (output-html-page "person_deleted.html" '() '() outputport))
                   (else (output-html-page "error.html" '("%error")
                                           "Could not delete person from Database"
                                           outputport))))))


; IG lidmaatschap overdracht van een vorig jaar
; ---------------------------------------------

; show form to lookup member
(define (draag-over-scm input outputport)
  (output-html-page "person_get.html" '("%nextpage")
                    '("select-person-for-overdracht") outputport))
		    
; show selection
(define (select-person-for-overdracht-scm input outputport)
  (select-person
    input
    outputport
    "update-person"
    (lambda (person)
      (person-update-form person outputport))))

; show form to update all data
(define (update-person-scm input outputport)
  (define personnumber (Get-Var-Value input "personnumber"))
  (if (not personnumber)
      (output-html-page "error.html" '("%error") (list "not a valid personnumber") outputport)
      (begin (define p (Create-Person))
             (p 'set 'personnumber personnumber)
             (define person (DB-Lookup-Person p))
             (cond ((null? person)
                    (output-html-page "error.html" '("%error") "Could not find person in Database" outputport))
                   ((null? '()) ;((cdr person)) ;only one match
                    (person-update-form (car person) outputport))
                   (else 
		    (output-html-page "error.html" '("%error")
		      '("personnumber is not unique!!!") outputport))))))

(define (draag-person-over-scm input outputport)
  (define person (Text-2-Person input))
  (if (null? person)
      (wrong-URL-format input outputport "add-person")
      (let ((status (person 'get 'status)))
        (cond ((string=? status "member")
               (person 'set 'membernumber (db-new-membernumber)))
              ((string=? status "honorary+member")
               (person 'set 'membernumber (db-new-honorarynumber))))
        (person 'set 'personnumber (db-new-personnumber))
        
        ;(define result (DB-addperson person))
        (define result #t)
        (if (null? result)
            (output-html-page "error.html" '("%error")
                              '("The member could not transferred to the next year.")
                              outputport)
            (show-person "person_overgedragen.html" person outputport)))))




; algemene en generische functies waarvan bovenstaande fucnties gebruik maken
; ---------------------------------------------------------------------------

; neemt een template, en spliced alle member-vars erin
(define (show-person templatefile person outputport) ;shows te list of all properties of a person just list, no form
  (display "showing properties")
  (display person)
  (output-html-page templatefile
                    '("%personnumber" "%membernumber" "%name" "%firstname"
		    "%studentid" "%function" "%direction" "%email" "%address1" "%phone1"
		    "%address2" "%phone2" "%internalphone" "%lastmemberyear" "%status"
		    "%dinfntlogin" "%login" "%password" "%accesslevel")
                    (list
                      (person 'get 'personnumber)
                      (person 'get 'membernumber)
                      (person 'get 'name)
                      (person 'get 'firstname)
                      (person 'get 'studentid)
                      (person 'get 'function)
                      (person 'get 'direction)
                      (person 'get 'email)
                      (person 'get 'address1)
                      (person 'get 'phone1)
                      (person 'get 'address2)
                      (person 'get 'phone2)
                      (person 'get 'internalphone)
                      (person 'get 'lastmemberyear)
                      (person 'get 'status)
                      (person 'get 'dinfntlogin)
		      (person 'get 'login)
		      (person 'get 'password)
                      (person 'get 'accesslevel))
                    outputport))

; laat een beknopte beschrijving zien van een person
(define (generate-person-list person-list outputport nextpage)
  (define (show-person-line person)
    (output-html-page "person_body.html"
                      '("%nextpage" "%personnumber" "%membernumber"
                                    "%name" "%firstname" "%studentid")
                      (list nextpage
                            (person 'get 'personnumber)
                            (person 'get 'membernumber)
                            (person 'get 'name)
                            (person 'get 'firstname)
                            (person 'get 'studentid))
                      outputport))
  (define (iter pl)
    (cond ((null? pl) #t)
          (else (show-person-line (car pl))
                (iter (cdr pl)))))
  (iter person-list))


; genereert een lijst van persons
(define (select-person input outputport nextpage directaction) ;action to perform when only one match
  (display "inside select-person")
  (define person (Text-2-Person input))
  (display "Text-2-Person succesfull   ") (display person)
  (if (null? person)
      (wrong-URL-format input outputport "lookup-person")
      (begin
        (display "before lookup")
        (define result (DB-lookup-Person person))
        (display "    result of lookup in DB was   ") (display result)
        (display "going to create output of lookup-person")
        (cond ((null? result)
	       (output-html-page '("%error") (list "No match for lookup") outputport))	      
	      ((string? result)
               (output-error result outputport))
              ((null? (cdr result))
                (display "only one match") 
                (directaction (car result))   ;one match
                (display "after 1 match"))
              (else ; several matches
                (output-html-page "person_header.html" '() '() outputport)
                (generate-person-list result outputport nextpage)
                (output-html-page "person_footer.html" '() '() outputport))))))



; zoekt een person op basis van de personnimber.
(define (DB-lookup-person-by-number personnumber outputport action)
  (display "LOOKUP_BY_NUMBER ")
  (if (not personnumber)
      (output-html-page '("%error") '("Not a valid personnumber") outputport)
      (begin (define p (Create-Person))
             (p 'set 'personnumber personnumber)
	     (display "before lookup")
             (define person (DB-Lookup-Person p))
	     (display "after lookup") (display person)
             (cond ((null? person)
	            (display " NOTHING FOUND")
                    (output-html-page "error.html" '("%error")
                                      "Could not find person in Database"
                                      outputport))
                   ((null? (cdr person))
		    (display "performing action")
                    (action (car person)))
                   (else (output-error "personnumber is not unique !!!" outputport))))))



(define (DB-replace-person-for-replace person outputport action)
  (display "inside DB_REPALE")
  (if (not person)
      (output-html-page '("%error") '("Not a valid personnumber") outputport)
      (begin 
        (display "inside begin")
        (define result (DB-replace-Person person))
        (cond ((string? result)
              (output-html-page "error.html" '("%error")
                                 result
                                 outputport))
              (else  (display "OK")
        	     (action person))))))



(define (person-update-form person outputport)
  (person 'set 'lastmemberyear (currentyear))
  (person 'set 'membernumber "")
  (show-person "person_update_for_overdracht.html" person outputport))





(define (currentyear) "1997")



(display "member funcs loaded")
(newline)


