; Reservatie-logika

; deze procedure wordt opgeroepen indien men in het menu de optie edit-reservations kiest
(define (Make-Reservation-scm input outputport)
  (output-html-page "reservation_make.html" '() '() outputport))
  
  ; functie voor het weergeven van de reservaties.
(define (View-Reservations-scm input outputport)
  (output-html-page "reservations_view.html" '() '() outputport))

(define (Delete-Reservations-scm input outputport)
  (output-html-page "reservation_del.html" '() '() outputport))

  ; Na het invullen van de form komt men hier terecht.
(define (Add-Reservation-scm input outputport)
  
  (define (generate-reservations reservation)
    (display "GENERATE-RESERVATIONS")
    (newline)
    (define weeks-string (reservation 'get 'week))
    (define weeks-vector (make-vector 52 #f))
    (define index 0)
    (define lengte (string-length weeks-string))
    
    (define (get-number str)
      (display "GET_NUMBER")
      (newline)
      (define (number-iter)
        (cond ((>= index lengte)
               str)
              ((or (string=? (string-ref weeks-string index) ",")
                   (string=? (string-ref weeks-string index) ">"))
               str)
              (else (begin (set! str (string-append str (string-ref weeks-string index)))
                           (set! index (+ index 1))
                           (number-iter)))))
      (number-iter))
    
    (define (generate)
      (display "GENERATE")
      (newline)
      (define listing '())
      (define maxi (vector-length weeks-vector))
      (define (generate-iter pos)
        (cond ((>= pos maxi)
               (display listing)
               (newline)
               listing)
              ((vector-ref weeks-vector pos)
               (let ((new-reservation (create-reservation)))
                 (new-reservation 'set 'id (reservation 'get 'id))
                 (new-reservation 'set 'room (reservation 'get 'room))
                 (new-reservation 'set 'start (reservation 'get 'start))
                 (new-reservation 'set 'stop (reservation 'get 'stop))
                 (new-reservation 'set 'day (reservation 'get 'day))
                 (new-reservation 'set 'course (reservation 'get 'course))
                 (new-reservation 'set 'week (number->string (vector-ref weeks-vector pos)))
                 (set! listing (cons new-reservation listing))
                 (generate-iter (+ pos 1))))
              (else (generate-iter (+ pos 1)))))
      (generate-iter 0))
    
    (define (iter)
      (if (>= index lengte)
          (generate)
          (let ((char (string-ref weeks-string index)))
            (set! index (+ index 1))
            
            (cond ((and (>= char "0")
                        (<= char "9"))
                   (let ((number (get-number char)))
                     (set! number (string->number number))
                     (cond ((> number 33)
                            '())
                           ((>= index lengte)
                            (vector-set! weeks-vector number number)
                            (generate))
                           ((string=? (string-ref weeks-string index) ">")
                            (set! index (+ index 1))
                            (let ((number2 (get-number "")))
                              (if (not (= (string-length number2) 0))
                                  (begin (set! number2 (string->number number2))
                                         (do ((aid number (+ aid 1)))
                                             ((< number2 aid))
                                             (vector-set! weeks-vector aid aid))
                                         (iter))
                                  '())))
                           ((string=? (string-ref weeks-string index) ",")
                            (vector-set! weeks-vector number number)
                            (set! index (+ index 1))
                            (iter))
                           (else (iter)))))
                  ((string=? char ",")
                   (iter))
                  (else '())))))
    (iter))
  
  (define (lookup-conflicts reservations)
    (display "LOOKUP CONFLICTS")
    (newline)
    (define conflict-list '())
    (if (null? reservations)
        '()
        (begin
          (display "processing conflict")
          (define first-reservation (car reservations))
          (define query-reservation (create-reservation))
          (define startuur (first-reservation 'get 'start))
          (define stopuur (first-reservation 'get 'stop))
          (query-reservation 'set 'room (first-reservation 'get 'room))
          (query-reservation 'set 'day (first-reservation 'get 'day))
          (do ()
              ((null? reservations) conflict-list)
              (let ((current (car reservations)))
                (set! reservations (cdr reservations))
                (query-reservation 'set 'week (current 'get 'week))
                (let ((conflict (db-lookup-room-reservation query-reservation)))
                  (display "CONFLICT :")
                  (display conflict)
                  (newline)
                  (if (string? conflict)
                      (output-error conflict outputport)
                      (do ()
                          ((null? conflict) conflict-list)
                          (let* ((current-conflict (car conflict))
                                 (startuur-conflict (current-conflict 'get 'start))
                                 (stopuur-conflict (current-conflict 'get 'stop)))
                            (set! conflict (cdr conflict))
                            (if (or (< stopuur stopuur-conflict)
                                    (> startuur startuur-conflict))
                                (set! conflict-list (cons current-conflict conflict-list))))))))))))
  
  (define (output-result reservations)
    (display "OUTPUT-RESULT")
    (newline)
    (display "RESERVATIONS:")
    (display reservations)
    (define (iter-result)
      (if (null? reservations)
          (output-html-page "reservation_made_footer.html" '() '() outputport)
          (let ((current (car reservations)))
            (display "HOWDIE")
            (set! reservations (cdr reservations))
            (display "CURRENT:")
            (display current)
            (define add-result (db-add-room-reservation current))
            (display "ADD_RESULT : ")
            (display add-result)
            (cond (add-result
                    (output-html-page "reservation_made_body.html" '("%week") (list (current 'get 'week)) outputport)
                    (display (current 'get 'week))
                    (iter-result))
                  ((string? add-result)
                   (output-error add-result outputport))
                  (else
                    (output-html-page "reservation_made_body.html" '("%week") '("Was not able to add reservation to dbase") outputport))))))
    
    (output-html-page "reservation_made_header.html" '("%room" "%start" "%stop")
                      (list (reservation 'get 'room)
                            (reservation 'get 'start)
                            (reservation 'get 'stop)) outputport)
    
    (iter-result))
  
  
  (define (output-conflicts conflicts)
    (output-html-page "reservations_conflicts.html" '() '() outputport))
  
  (display "entering make-reservation")
  (define reservation (Text-2-Reservation input))
  (display "text2reservation succesfull")
  (newline)
  (if (null? reservation)
      (wrong-URL-format input outputport "make-reservation")
      (begin
        (define generated-reservations (generate-reservations reservation))
        (if (null? generated-reservations)
            (output-html-page "error.html" '("%error") '("Wrong input") outputport)
            (let* ((conflicts (lookup-conflicts generated-reservations))
                   (maxi (length conflicts)))
              (if (not (null? conflicts))
                  (output-conflicts conflicts)
                  (output-result generated-reservations)))))))
  
  
  
(define (view-reservation-week-scm input outputport)
  (define week (get-var-value input "week"))
  (define room (get-var-value input "room"))
  (display "ROOM:")
  (display room)
  (define status #t)
  (define templatefile "")
  (display "ENTERING VIEW_WEEK")
  (define (build-var-val-list reservations)
    (define vars (list "%MO_8"
                       "%TE_8"
                       "%WE_8"
                       "%TH_8"
                       "%FR_8"
                       "%SA_8"
                       "%MO_9"
                       "%TE_9"
                       "%WE_9"
                       "%TH_9"
                       "%FR_9"
                       "%SA_9"
                       "%MO_10"
                       "%TE_10"
                       "%WE_10"
                       "%TH_10"
                       "%FR_10"
                       "%SA_10"
                       "%MO_11"
                       "%TE_11"
                       "%WE_11"
                       "%TH_11"
                       "%FR_11"
                       "%SA_11"
                       "%MO_12"
                       "%TE_12"
                       "%WE_12"
                       "%TH_12"
                       "%FR_12"
                       "%SA_12"
                       "%MO_13"
                       "%TE_13"
                       "%WE_13"
                       "%TH_13"
                       "%FR_13"
                       "%SA_13"
                       "%MO_14"
                       "%TE_14"
                       "%WE_14"
                       "%TH_14"
                       "%FR_14"
                       "%SA_14"
                       "%MO_15"
                       "%TE_15"
                       "%WE_15"
                       "%TH_15"
                       "%FR_15"
                       "%SA_15"
                       "%MO_16"
                       "%TE_16"
                       "%WE_16"
                       "%TH_16"
                       "%FR_16"
                       "%SA_16"
                       "%MO_17"
                       "%TE_17"
                       "%WE_17"
                       "%TH_17"
                       "%FR_17"
                       "%SA_17"
                       "%MO_18"
                       "%TE_18"
                       "%WE_18"
                       "%TH_18"
                       "%FR_18"
                       "%SA_18"
                       "%MO_19"
                       "%TE_19"
                       "%WE_19"
                       "%TH_19"
                       "%FR_19"
                       "%SA_19"
                       "%MO_20"
                       "%TE_20"
                       "%WE_20"
                       "%TH_20"
                       "%FR_20"
                       "%SA_20"
                       "%MO_21"
                       "%TE_21"
                       "%WE_21"
                       "%TH_21"
                       "%FR_21"
                       "%SA_21" ))
    (define vals (vector '0 '1 '2 '3 '4 '5 '6 '7 (vector ""
                                                         ""
                                                         ""
                                                         ""
                                                         ""
                                                         "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector""
                                ""
                                ""
                                ""
                                ""
                                "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")
                         (vector ""
                                 ""
                                 ""
                                 ""
                                 ""
                                 "")))
    (define (iter rest)
      (display "ITRATE")
      (if (and (not (null? rest))
               status)
          (let* ((current (car rest))
                 (current-personnumber (current 'get 'id))
                 (current-day (current 'get 'day))
                 (current-starthour (current 'get 'start))
                 (current-stophour (current 'get 'stop))
                 (current-course (current 'get 'course))
                 (person (create-person))
                 (person-name ""))
		 (display "HERE I AM")
	    (newline)
            (display  current-personnumber)
	    (person 'set 'personnumber current-personnumber)
            (define person-list (db-lookup-person person))
            (display person-list)
	    (cond ((and (list? person-list)
                        (= 1 (length person-list)))
                   (set! person-name ((car person-list) 'get 'name)))
                  ((null? person-list)
                   (set! status #f)
                   (output-error "Database is inconsistent" outputport))
                  ((string? person-list)
                   (set! status #f)
                   (output-error person-list outputport)))
            (display "here")
	    (cond ((string=? current-day "monday")
                   (set! current-day 0))
                  ((string=? current-day "tuesday")
                   (set! current-day 1))
                  ((string=? current-day "wednesday")
                   (set! current-day 2))
                  ((string=? current-day "thursday")
                   (set! current-day 3))
                  ((string=? current-day "friday")
                   (set! current-day 4))
                  ((string=? current-day "saturday")
                   (set! current-day 5))
                  (else
                    (set! status #f)
                    (output-error "Day is not correct" outputport)))
            (set! current-stophour (string->number current-stophour))
	    (do ((hour (string->number current-starthour) (+ hour 1)))
                ((>= hour current-stophour))
                (vector-set! (vector-ref vals hour) current-day
(string-append person-name ":" current-course)))
            (iter (cdr rest)))))
    
    (define (convert index)
      (display "CONVERTING")
      (if (>= index 22)
          (list)
          (append (vector->list (vector-ref vals index)) (convert (+ index 1)))))
    
    (iter reservations)
    (display "ITER DONE")
    (let ((values (convert 8)))
      (output-html-page templatefile vars values outputport)))
  
  
  (if (or (null? room)
          (null? week))
      (output-error "The received URL was not valid" outputport)
      (begin
        (set! templatefile (string-append room "_reservations_view.html"))
        (define db-query (create-reservation))
        (db-query 'set 'week week)
        (db-query 'set 'room room)
        (define db-result (db-lookup-room-reservation db-query))
        (build-var-val-list db-result))))

(define (del-reservation-scm input outputport)
   
   (define room (get-var-value input "room"))
   (define starthour (get-var-value input "start"))
   (define stophour (get-var-value input "stop"))
   (define week (get-var-value input "week"))

  (define (output-result reservations)
    (display "OUTPUT-RESULT")
    (newline)
    (display "RESERVATIONS:")
    (display reservations)
    (define (iter-result)
      (if (null? reservations)
          (output-html-page "reservation_del_footer.html" '() '() outputport)
          (let ((current (car reservations)))
            (display "HOWDIE")
            (set! reservations (cdr reservations))
            (display "CURRENT:")
            (display current)
            (output-html-page "reservation_del_body.html"
	                       '("%room" "%week" "%start" "%stop" "%day")
			        (list (current 'get 'room)
				      (current 'get 'week)
	                              (current 'get 'start)
				      (current 'get 'stop)
				      (current 'get 'day))
				outputport)
            (iter-result))))
            
    
    (output-html-page "reservation_del_header.html" '() '() outputport)
                          
    (iter-result))



   (if (or (null? room)
           (null? starthour)
	   (null? stophour)
	   (null? week))
       (output-error "Not enough parameters" outputport)
       (let ((query (create-reservation)))
           (query 'set 'room room)
	   (query 'set 'start starthour)
	   (query 'set 'stop  stophour)
	   (if (not (string=? global_accesslevel "reservatieadmin"))
	       (query 'set 'id id))
	   (query 'set 'week week)
	   
	   (let ((look-result (db-lookup-room-reservation query)))
	       (display "RESULT OF LOOKUP RESERVATION :")
	       (display look-result)
	       (cond ((null? look-result)
	              (output-error "No reservations found" outputport))
		     ((string? look-result)
		      (output-error look-result outputport))
		     (else (output-result look-result)))))))
		     
		     
		     
		     
		     
(define (confirm-delete-scm input outputport)

   (define room (get-var-value input "room"))
   (define starthour (get-var-value input "start"))
   (define stophour (get-var-value input "stop"))
   (define week (get-var-value input "week"))
  
   (if (or (null? room)
           (null? starthour)
	   (null? stophour)
	   (null? week))
       (output-error "Not enough parameters" outputport)
       (let ((query (create-reservation)))
           (query 'set 'room room)
	   (query 'set 'start starthour)
	   (query 'set 'stop  stophour)
	   (if (not (string=? global_accesslevel "reservatieadmin"))
	       (query 'set 'id id))
	   (query 'set 'week week)
	  	   
	   (let ((del-result (db-delete-room-reservation query)))
	       
	       (cond ((not del-result)
	              (output-error "No reservations found" outputport))
		     ((string? del-result)
		      (output-error del-result outputport))
		     (else (output-html-page "reservation_deleted.scm" '() '() outputport)))))))

